//
//      httpsapp.cpp
//

#include "httpsapp.hpp"

#define SSL_BOOST // SSL ̃ptH[}Xu[Xg

#if TARGET_VERSION_LT(3, 1, 4)
#ifdef SSL_BOOST
#include "AEESSL_WEBOPT_CLASSID.h"
#include "ISSL.bid"
#endif
#endif

// u[g [_
SFCApplet::FactorySPP SFCApplet::Boot(AEECLSID id, SFXAnsiStringPtr license)
{
    *license = "heap://"
        "RNZBVQSNU68PV0UNWPSNT0U0YHR3X09YJTLRGVLW9Y8R0WNZAV3Q3S84X6W0UQWCT3XQ"
        "3VQDHRJSNU8NUGRJUOXOWOR8UORKV0VMSLY6SOMW5U96X2Y4T5YPT3SIS9WNOU6R1TGS"
        "MUMVNVNJY0Y14UFLVJX62R7TLUEWHR8ULU3VCS2XEVHTIRFTQSFY7Y4V2CV3V6WKX8RO"
        "UITLX05Z7W0Z97WKVQZBRPUBWQX3Y7X1RLSI4U9S1SCS4RJW9VCTJRQ5V0R2TOYDDXMX"
        "IXMZ2TBATHS0TGW0R4T6S0W7XJUI8UQZCZAV4XOVOSKWQXKSAVNUPWGW7R7RCWKDV5R4"
        "UCV5VOTBVQT1IY1TN"
    "/";

    return (id == AEECLSID_HTTPSAPP) ? (&httpsapp::Factory) : (null);
}

// t@Ng֐
SFCInvokerPtr httpsapp::Factory(Void)
{
    return ::new httpsapp;
}

// RXgN^
httpsapp::httpsapp(Void) static_throws
{
    if (static_try()) {
        static_throw(ConstructRootCerts());
    }
}

// fXgN^
httpsapp::~httpsapp(Void)
{
}

// Cxg nh
Bool httpsapp::HandleEvent(SFXEventConstRef event)
{
    Bool result(false);

    switch (event.GetType()) {
        case SFEVT_APP_START:
            result = true;
            break;
        case SFEVT_KEY:
            result = OnKey(event.GetP16());
    }
    return result;
}

// `nh
Bool httpsapp::HandleRender(SFXEventConstRef event)
{
    unused(event);

    SFXGraphicsPtr graphics;
    Bool result(false);

    if (IsRenderable()) {
        graphics = SFXGraphics::GetInstance();
        if (graphics != null) {
            SFXRectangle rc, rc1, rc2, rc3, rc4, rc5;
            rc.Set(graphics->GetDeviceRectangle());
            rc1.Set(5, 10, rc.GetWidth(), 20);
            rc2.Set(5, 35, rc.GetWidth(), 20);
            rc3.Set(5, 60, rc.GetWidth(), 20);
            rc4.Set(5, 85, rc.GetWidth(), 20);
            rc5.Set(5, 110, rc.GetWidth(), 20);
            graphics->ClearRectangle(rc, SFXRGBColor(0xFF, 0xFF, 0xFF, 0x00));
            graphics->DrawSingleText("1. verisign", rc1, SFXRGBColor(0x00, 0x00, 0x00, 0x00), IDF_ALIGN_LEFT);
            graphics->DrawSingleText("2. verisign 7", rc2, SFXRGBColor(0x00, 0x00, 0x00, 0x00), IDF_ALIGN_LEFT);
            graphics->DrawSingleText("3. cybertrust a", rc3, SFXRGBColor(0x00, 0x00, 0x00, 0x00), IDF_ALIGN_LEFT);
            graphics->DrawSingleText("4. cybertruct linkbylink", rc4, SFXRGBColor(0x00, 0x00, 0x00, 0x00), IDF_ALIGN_LEFT);
            graphics->DrawSingleText("5. scradle", rc5, SFXRGBColor(0x00, 0x00, 0x00, 0x00), IDF_ALIGN_LEFT);
            graphics->Update();
            result = true;
        }
    }
    return result;
}

// L[nh
Bool httpsapp::OnKey(UInt16 key)
{
    Bool result(false);

    switch (key) {
        case AVK_1:
            Connect("https://www.verisign.co.jp");
            result = true;
            break;
        case AVK_2:
            Connect("https://ssltest7.verisign.co.jp/");
            result = true;
            break;
        case AVK_3:
            Connect("https://www.cybertrust.ne.jp/a/");
            result = true;
            break;
        case AVK_4:
            Connect("https://www.cybertrust.ne.jp/a/linkbylink.hdml");
            result = true;
            break;
        case AVK_5:
            Connect("https://www.s-cradle.com");
            result = true;
            break;
        case AVK_CLR:
        case AVK_SELECT:
            Terminate();
            result = true;
    }
    return result;
}

// w URL  https ڑ
Void httpsapp::Connect(SFXAnsiStringConstRef url)
{
    // SFXHTTPConnection NX𗘗p
    // HTTP / HTTPS ڑyɗp邱Ƃł܂B
    // ̃TvR[hł́AG[
    // ʐM\[X̉𖾎IɋLqĂ܂B
    // ĂȂ\[X̓AvbgIɎI
    // ܂AHIȃAvbgł͒ʐMG[
    // ʐMɖIɃ\[XׂłB

    SFCError error(SFERR_NO_ERROR);

    _http.Close();

    TRACE("");
    TRACE("...%s", url.GetCString());
    TRACE("");

    // SFXHTTPConnection NXJ
    error = _http.Open();
    if (error == SFERR_NO_ERROR) {

        _http.SetMethod("GET");

        // F؃[h SSL_TRUST_MODE_FAIL ɐݒ
        _http.SetTrustMode(SSL_TRUST_MODE_FAIL);

        // [gؖǉ
        // ̏͐ڑTCgW̃[gؖɊ܂܂ȂꍇɕKvłB
        // W̃[gؖ͋@ɂĎ኱قȂ܂B
        error = AddRootCerts();
        if (error == SFERR_NO_ERROR) {

            // HTTPS ڑ
            if (_http.Connect(url, XALLBACK_INTERNAL(OnConnect)) == SFERR_NO_ERROR) {
                TRACE("start connecting...");
            }

        }
        else {
            TRACE("error %d: AddRootCert", error);
        }
    }
    else {
        TRACE("error %d: _http.Open", error);
    }
    return;
}

// ڑɌĂяoR[obN֐
XALLBACK_IMPLEMENT_SFXHTTPCONNECTION(httpsapp, OnConnect, error)
{
    SFXPropertyConstPtr header;
    SInt16 i;

    // ڑ̃G[`FbN

    TraceSSLInfo(0);

    if (error == SFERR_NO_ERROR) {
        TRACE("connected...");

        // ep[^\

        TRACE("result code = %d", _http.GetResultCode());
        TRACE("content length = %d", _http.GetLength());
        TRACE("content type = %s", _http.GetType().GetCString());
        TRACE("content encoding = %s", _http.GetEncoding().GetCString());
        TRACE("date = %s", _http.GetDate().Format("YYYY/MM/DD hh:mm:ss").GetCString());
        TRACE("expires = %s", _http.GetExpires().Format("YYYY/MM/DD hh:mm:ss").GetCString());
        TRACE("last modified = %s", _http.GetLastModified().Format("YYYY/MM/DD hh:mm:ss").GetCString());

        // X|Xwb_ׂĕ\

        TRACE("--- headers ---");
        header = &_http.GetResponseHeader();
        for (i = 0; i < header->GetSize(); ++i) {
            TRACE("%s: %s", header->GetKey(i).GetCString(), header->GetValue(i).GetCString());
        }
        TRACE("---------------");

        // Regǂݍނ߂̃Xg[擾

        if (_http.GetStreamReader(1024, &_reader) == SFERR_NO_ERROR) {

            // ̃_E[ht@C폜

            SFXFile::Remove(SFXPath("download.html"));

            // _E[ht@CJ

            if (_file.OpenReadWrite(SFXPath("download.html")) == SFERR_NO_ERROR) {

                // t@Cɏނ߂̃Xg[擾

                if (_file.GetStreamWriter(1024, &_writer) == SFERR_NO_ERROR) {

                    // Regǂݍ݊Jn

                    if (_reader.Fetch(XALLBACK_INTERNAL(OnFetch)) == SFERR_NO_ERROR) {
                        TRACE("start fetching...");
                    }
                }
            }
        }
    }
    else {
        TRACE("connection error: %d...", error);
    }
    return;
}

// Reg擾ƌĂяoR[obN֐
XALLBACK_IMPLEMENT_SFXANSISTRINGSTREAMREADER(httpsapp, OnFetch, error)
{
    SFXAnsiString temp;

    // ڑ̃G[`FbN

    if (error == SFERR_NO_ERROR) {

        // lbg[NXg[擾̃f[^ǂݍ

        if (_reader.ReadSFXAnsiString(&temp) == SFERR_NO_ERROR) {

            // t@CXg[ɏ

            if (_writer.WriteSFXAnsiString(temp) == SFERR_NO_ERROR) {

                // ۂ̃t@CɏoAt@CXg[tbV

                _writer.Flush();
            }
        }

        // f[^ׂĎ擾ꂽ`FbN

        if (_reader.Ends()) {

            TRACE("fetched...");
            TRACE("");

            // e탊\[X𖾎Iɉ

            _writer.Release();
            _file.Close();
            _reader.Release();
            _http.Close();
        }
        else {

            // f[^cĂꍇ͍Ď擾

            _reader.Fetch(XALLBACK_INTERNAL(OnFetch));
        }
    }
    return;
}

// [gؖ\z
SFCError httpsapp::ConstructRootCerts(Void)
{
    static ACharConst certFiles[CERT_COUNT][16] = {
        "verisign.cer",
        "verisign7.cer",
        "gteglroot.cer",
        "scradle.der"
    };
    SFCError error(SFERR_NO_ERROR);

    _chain = SFBX509Chain::NewInstance(&error);
    if (_chain != null) {
        for (SIntN i = 0; i < CERT_COUNT; i++) {
            error = RetrieveFileBuffer(certFiles[i], &_certBuf[i]);
            if (error == SFERR_NO_ERROR) {

                TRACE("%s %d byte", certFiles[i], _certBuf[i].GetSize());
                error = _chain->AddCert(WEBOPT_X509_ROOT_CERTS, (ByteConstPtr)_certBuf[i].GetBuffer(), _certBuf[i].GetSize());

            }
        }
    }
    if (error != SFERR_NO_ERROR) {
        _chain.Release();
    }
    return error;
}

// t@CǂݍŃobt@Ɏ荞
SFCError httpsapp::RetrieveFileBuffer(SFXAnsiStringConstRef fileName, SFXBufferPtr buffer)
{
    SFXFile file;
    SFXBinaryStreamReader reader;
    SFXPath path(fileName);
    SFXBuffer temp;
    SFCError error(SFERR_NO_ERROR);

    if (buffer != null) {
        buffer->SetSize(0);
        error = file.OpenReadOnly(path);
        if (error == SFERR_NO_ERROR) {
            error = file.GetStreamReader(1024, &reader);
            if (error == SFERR_NO_ERROR) {
                while (!reader.Ends()) {
                    error = temp.SetSize(reader.GetReadableSize());
                    if (error != SFERR_NO_ERROR) {
                        break;
                    }
                    error = reader.Fetch();
                    if (error != SFERR_NO_ERROR) {
                        break;
                    }
                    error = reader.Read(&temp);
                    if (error != SFERR_NO_ERROR) {
                        break;
                    }
                    error = buffer->Add(temp);
                    if (error != SFERR_NO_ERROR) {
                        break;
                    }
                }
            }
        }
        if (error != SFERR_NO_ERROR) {
            buffer->SetSize(0);
        }
    }
    else {
        error = SFERR_INVALID_PARAM;
    }
    return error;
}

// [gؖǉ
SFCError httpsapp::AddRootCerts(Void)
{
    SFCError error(SFERR_NO_ERROR);

    if (_chain != null) {
        SFBWebSmp web = _http.GetSFBWeb();
        if (web != null) {
            WebOpt opts[3];
            SIntN i(0);
            opts[i].nId = WEBOPT_DEFAULTS;
            opts[i].pVal = _chain.Get();
            ++i;
            #if TARGET_VERSION_LT(3, 1, 4)
            #ifdef SSL_BOOST
            opts[i].nId = WEBOPT_SSL_CLASSID;
            opts[i].pVal = (VoidPtr)AEECLSID_SSL_101;
            ++i;
            #endif
            #endif
            opts[i].nId = WEBOPT_END;
            opts[i].pVal = null;
            error = web->AddOpt(opts);
        }
        else {
            error = SFERR_FAILED;
        }
    }
    else {
        error = SFERR_FAILED;
    }
    return error;
}

// SSL \̂̓eg[X
SFCError httpsapp::TraceSSLInfo(UInt32 index)
{
    WebOpt opt;
    SFBWebRespSmp webresp;
    SSLInfo* info;
    SFCError error(SFERR_NO_ERROR);

    webresp = _http.GetSFBWebResp();
    if (webresp != null) {
        error = webresp->GetOpt(WEBOPT_SSL_SEC_INFO, index, &opt);
        if (error == SFERR_NO_ERROR) {
            info = (SSLInfo*)opt.pVal;
            if (info != null) {
                TRACE("SSLInfo...");
                TRACE(" SSLInfo.nResult: %s", sslresult(info->nResult));
                TRACE(" SSLInfo.SecInfo...");
                TRACE("  ProtoVersion: %s", protoversion(info->SecInfo.uProtoVersion));
                TRACE("  KeyExchange: %s", keyprot(info->SecInfo.uKeyExchange));
                TRACE("  CryptAlgo: %s", cryptalgo(info->SecInfo.uCryptAlgo));
                TRACE("  HashAlgo: %s", hashalgo(info->SecInfo.uHashAlgo));
                TRACE("  CipherSuite: %s", ciphersuite(info->SecInfo.uCipherSuite));
                TRACE(" SSLInfo.TrustResult...");
                TRACE("  Result: %d", info->TrustResult.nResult);
                TRACE("  ChainLen: %d", info->TrustResult.nChainLen);
                TRACE("  auChainErrors...");
                for (SIntN i = 0; i < X509CHAIN_MAX_CHAIN; i++) {
                    TRACE("   %d", info->TrustResult.auChainErrors[i]);
                }
                TRACE("  ErrorSummary: %d", info->TrustResult.uErrorSummary);
                TRACE("");
            }
            else {
                error = SFERR_FAILED;
            }
        }
    }
    else {
        error = SFERR_FAILED;
    }
    return error;
}

ACharConstPtr httpsapp::sslresult(UInt32 n)
{
    static ACharConst SSLResult[][64] = {
        "SSL_RESULT_SECURED",
        "SSL_RESULT_ALGS_ERR",
        "SSL_RESULT_TRUST_ERR",
        "SSL_RESULT_CERT_ERR",
        "SSL_RESULT_PROTO_ERR",
        "SSL_RESULT_CLIENT_AUTH_ERR",
        "SSL_RESULT_CLOSED",
        "SSL_RESULT_HANDSHAKE",
        "SSL_RESULT_UNINITIALIZED",
        "SSL_RESULT_ERR",
        "SSL_RESULT_VERS_UNSUP",
        "SSL_RESULT_CSUITE_UNSUP",
        "SSL_RESULT_SERV_VERS",
        "SSL_RESULT_TRUST_CHECK",
        "SSL_RESULT_SOCKET_ERROR",
        "SSL_RESULT_SECURITY_LEVEL_ERR",
        "SSL_RESULT_CLOSE_NOTIFY_SENT",
        "SSL_RESULT_BAD_SERVER_KEY",
        "SSL_RESULT_BAD_STATE"
    };
    return SSLResult[n - SSL_ERROR_BASE];
}

ACharConstPtr httpsapp::protoversion(UInt16 n)
{
    static ACharConst ver0[] = "SSL_VERSION_30";
    static ACharConst ver1[] = "SSL_VERSION_TLS10";
    static ACharConst ver2[] = "SSL_VERSION_UNKNOWN";

    switch(n) {
    case SSL_VERSION_30:
            return ver0;
    case SSL_VERSION_TLS10:
            return ver1;
        default:
            return ver2;
    }
}

ACharConstPtr httpsapp::keyprot(UInt08 n)
{
    static ACharConst KEYProt[][64] = {
        "SSL_KEYPROT_NONE",
        "SSL_KEYPROT_DH_ANONYMOUS",
        "SSL_KEYPROT_DH_EPHEMERAL",
        "SSL_KEYPROT_DH_DSS_SIGN",
        "SSL_KEYPROT_DH_RSA_SIGN",
        "SSL_KEYPROT_DH_DSS_CERT",
        "SSL_KEYPROT_DH_RSA_CERT",
        "SSL_KEYPROT_RSA",
        "SSL_KEYPROT_UNKNOWN"
    };
    if (n < 8) {
        return KEYProt[n];
    }
    return KEYProt[8];
}

ACharConstPtr httpsapp::cryptalgo(UInt08 n)
{
    static ACharConst CRYPT[][64] = {
        "SSL_CRYPT_NONE",
        "SSL_CRYPT_RC4",
        "SSL_CRYPT_DES",
        "SSL_CRYPT_3DES",
        "SSL_CRYPT_SEED",
        "SSL_CRYPT_AES128",
        "SSL_CRYPT_AES256",
        "SSL_CRYPT_UNKNOWN"
    };
    if (n < 7) {
        return CRYPT[n];
    }
    return CRYPT[7];
}

ACharConstPtr httpsapp::hashalgo(UInt08 n)
{
    static ACharConst HASH[][64] = {
        "SSL_HASH_NONE",
        "SSL_HASH_SHA_1",
        "SSL_HASH_MD5",
        "SSL_HASH_UNKNOWN"
    };
    if (n < 3) {
        return HASH[n];
    }
    return HASH[3];
}

ACharConstPtr httpsapp::ciphersuite(UInt16 n)
{
    static ACharConst CIPHERSUITE[][64] = {
        "SSL_CSUITE_RSA_WITH_RC4_128_MD5",
        "SSL_CSUITE_RSA_WITH_RC4_128_SHA",
        "SSL_CSUITE_RSA_WITH_DES_CBC_SHA",
        "SSL_CSUITE_RSA_WITH_3DES_EDE_CBC_SHA",
        "SSL_CSUITE_RSA_WITH_SEED_CBC_SHA",
        "SSL_CSUITE_RSA_WITH_AES_128_CBC_SHA",
        "SSL_CSUITE_RSA_WITH_AES_256_CBC_SHA",
        "SSL_CSUITE_UNKNOWN"
    };
    switch (n) {
        case SSL_CSUITE_RSA_WITH_RC4_128_MD5:
            return CIPHERSUITE[0];
        case SSL_CSUITE_RSA_WITH_RC4_128_SHA:
            return CIPHERSUITE[1];
        case SSL_CSUITE_RSA_WITH_DES_CBC_SHA:
            return CIPHERSUITE[2];
        case SSL_CSUITE_RSA_WITH_3DES_EDE_CBC_SHA:
            return CIPHERSUITE[3];
        case SSL_CSUITE_RSA_WITH_SEED_CBC_SHA:
            return CIPHERSUITE[4];
        #if TARGET_VERSION_GE(4, 0, 0)
        case SSL_CSUITE_RSA_WITH_AES_128_CBC_SHA:
            return CIPHERSUITE[5];
        case SSL_CSUITE_RSA_WITH_AES_256_CBC_SHA:
            return CIPHERSUITE[6];
        #endif
        default:
            return CIPHERSUITE[7];
    }
}
