//
//      httpsapp.hpp
//

#ifndef __HTTPSAPP_HPP
#define __HTTPSAPP_HPP

#define TARGET_BUILD_DEBUG
#include <SophiaFramework.hpp>
#include "httpsapp.bid"

SFMTYPEDEFCLASS(httpsapp)
class httpsapp : public SFCApplication {
    SFMSEALCOPY(httpsapp)
public:
    enum CertEnum {
        CERT_VERISIGN,
        CERT_VERISIGN7,
        CERT_CYBERTRUST,
        CERT_SCRADLE,
        CERT_COUNT
    };
    SFMTYPEDEFTYPE(CertEnum)
private:
    SFXHTTPConnection           _http;
    SFXAnsiStringStreamReader   _reader;
    SFBX509ChainSmp             _chain;
    SFXBuffer                   _certBuf[CERT_COUNT];
    SFXFile                     _file;
    SFXAnsiStringStreamWriter   _writer;

public:
    static SFCInvokerPtr Factory(Void);
private:
    explicit httpsapp(Void) static_throws;
    virtual ~httpsapp(Void);
    virtual Bool HandleEvent(SFXEventConstRef event);
    virtual Bool HandleRender(SFXEventConstRef event);

    // L[nh
    Bool OnKey(UInt16 key);

    // w URL  https ڑ
    Void Connect(SFXAnsiStringConstRef url);

    // [gؖ\z
    SFCError ConstructRootCerts(Void);

    // t@CǂݍŃobt@Ɏ荞
    SFCError RetrieveFileBuffer(SFXAnsiStringConstRef certName, SFXBufferPtr buffer);

    // [gؖǉ
    SFCError AddRootCerts(Void);

    // SSL \̂̓eg[X
    SFCError TraceSSLInfo(UInt32 index);

    XALLBACK_DECLARE_SFXHTTPCONNECTION(OnConnect)
    XALLBACK_DECLARE_SFXANSISTRINGSTREAMREADER(OnFetch)

    static ACharConstPtr sslresult(UInt32 n);
    static ACharConstPtr protoversion(UInt16 n);
    static ACharConstPtr keyprot(UInt08 n);
    static ACharConstPtr cryptalgo(UInt08 n);
    static ACharConstPtr hashalgo(UInt08 n);
    static ACharConstPtr ciphersuite(UInt16 n);
};

#endif // __HTTPSAPP_HPP //
